﻿using Contract;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Server
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Server is sending broadcasts.");
            double d = 0;

            ChannelFactory<IStockService> factory = new ChannelFactory<IStockService>("stock");

            IStockService client = factory.CreateChannel();
            CancellationTokenSource cts = new CancellationTokenSource();

            Task worker = Task.Run(() =>
            {

                while (!cts.Token.IsCancellationRequested)
                {
                    Console.WriteLine(d);
                    client.GetStock("test", d++);
                    Thread.Sleep(200);
                }
            }, cts.Token);

            Task worker2 = Task.Run(() =>
            {

                while (!cts.Token.IsCancellationRequested)
                {
                    string fastesClient = client.GetFastesClient();
                    Console.WriteLine(fastesClient);
                    Thread.Sleep(2000);
                }
            }, cts.Token);



            Console.WriteLine("Press any key to stop server.");

            Console.ReadKey();
            cts.Cancel();

        }
    }
}
