﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace tps_sample
{
    /// <summary>
    /// Interaction logic for PartitioningSample.xaml
    /// </summary>
    public partial class PartitioningSample : UserControl
    {
        public ObservableCollection<string> Values { get; set; }
        private object _lock = new object();

        public PartitioningSample()
        {
            Values = new ObservableCollection<string>();
            BindingOperations.EnableCollectionSynchronization(Values, _lock);
            this.DataContext = this;
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {

            Parallel.ForEach(
                Partitioner.Create(CreateDates(0, 20), 
                EnumerablePartitionerOptions.NoBuffering), 
                i => Values.Add(

              "created: " + i.ToString("mm:ss.ff") + " -> used: " + DateTime.Now.ToString("mm:ss.ff")));

        }

        private IEnumerable<DateTime> CreateDates(int from, int to)
        {
            for (int i = from; i < to; i++)
            {
                Thread.Sleep(50);
                yield return DateTime.Now;
            }
        }



        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            Parallel.ForEach(
                CreateDates(0, 20),
                i => Values.Add("created: " + i.ToString("mm:ss.ff") + " -> used: " + DateTime.Now.ToString("mm:ss.ff"))                );

        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            Values.Clear();
        }
    }
}
